This file, NUWEB.CH, is part of AMI-NUWEB 0.87b.
It is a changefile for NUWEB.W 0.87b.  The `l.XXX' numbers refer to this
specific version of the original source code and may be out of date in
future patches.

Author:
(AS) Andreas Scherer, RWTH Aachen,
  (scherer@@genesis.informatik.rwth-aachen.de).

This document is distributed WITHOUT ANY WARRANTY, express or implied.

The following copyright notice extends to this changefile only, not to the
masterfile NUWEB.W.

Copyright (c) 1994 Andreas Scherer.  All rights destroyed.

Version history:

Version	Date		Author	Comment
a1	06 Oct 1994	AS	Set up for NUWEB.W 0.87b.
a2	07 Oct 1994	AS	Fixed an Overful \hbox error.
				Upload to CTAN (ftp.dante.de).
				Upload to AmiNet (ftp.uni-passau.de).
a3	07 Oct 1994	AS	(Evening, sorry.) Numerous refinements
				after printing the source documentation.
a4	08 Oct 1994	AS	German version implemented.
				This feature works on the Amiga only, but
				for other languages as well.
a5	09 Oct 1994	AS	Fix a newly introduced bug in the file
				comparison mechanism.

----------------------------------------------------------------------------

@x l.1
\documentstyle{report}
@y
\documentclass{report}
\usepackage{latexsym}

@z

@x l.52
automatically generated indices and cross-references that made it much
@y
automatically generated indexes and cross-references that made it much
@z

@x l.74
perhaps suffers from being overly Unix-dependent and requiring several
@y
perhaps suffers from being overly UNIX-dependent and requiring several
@z

@x l.213
Basically, the programmer need only type enough characters to uniquely
@y
Basically, the programmer needs only type enough characters to uniquely
@z

@x l.240
  many Unix systems since they cause the compiler's error messages to
@y
  many UNIX systems since they cause the compiler's error messages to
@z

@x l.263
Finally, there are three commands used to create indices to the macro
@y
Finally, there are three commands used to create indexes to the macro
@z

@x l.267
\item[\tt @@m] Create an index of macro name.
@y
\item[\tt @@m] Create an index of macro names.
@z

@x l.271
in the \LaTeX\ document; for example, see Chapter~\ref{indices}.
@y
in the \LaTeX\ document; for example, see Chapter~\ref{indexes}.
@z

@x l.357
that file.  The documentations section will be jumbled, but the
@y
that file.  The documentation sections will be jumbled, but the
@z

@x l.378
  (PRE), so macros may contain one or more A, B, I, U, or P elements
@y
  (PRE), so macros may contain one or more A, B, I, U or P elements
@z

@x l.409
never have heard or nuweb (or many other tools) without the efforts of
@y
never have heard of nuweb (or many other tools) without the efforts of
@z

@x l.442
We'll need at least three of the standard system include files.
@y
We'll need at least four of the standard system include files.
@z

@x l.449
toupper isupper islower isgraph isspace tempnam remove malloc size_t @}
@y
toupper isupper islower isgraph isspace tmpnam remove malloc size_t @}
@z

@x l.455
definitions of \verb|TRUE| and \verb|FALSE| be default.  The following
@y
definitions of \verb|TRUE| and \verb|FALSE| by default.  The following
@z

@x l.469
The code is divided into four main files (introduced here) and five
@y
The code is divided into five main files (introduced here) and five
@z

@x l.478
It handles collection of all the file names, macros names, and scraps
@y
It handles collection of all the file names, macro names, and scraps
@z

@x l.535
Finally, for best portability, I seem to need a file containing
(useless!) definitions of all the global variables.
@o global.c
@{#include "global.h"
@y
Finally, for best portability, I seem to need a file containing
(useless!) definitions of all the global variables.

System dependent parts can be introduced here as well, e.g., on the Amiga
we introduce the capability of multilinguality in both the terminal output
and the \LaTeX\ output.  To activate the necessary variables and arrays,
the value \verb|STRINGARRAY| must be set.

@o global.c
@{#ifdef _AMIGA
#define STRINGARRAY 1
#endif
#include "global.h"
@z

@x l.548
@{int main(argc, argv)
     int argc;
     char **argv;
@y
@{void main(int argc, char **argv)
@z

@x l.553
  @<Interpret command-line arguments@>
  @<Process the remaining arguments (file names)@>
  exit(0);
}
@| main @}
@y
  @<Use catalog translations@>
  @<Interpret command-line arguments@>
  @<Process the remaining arguments (file names)@>
  exit(EXIT_SUCCESS);
} @| main EXIT_SUCCESS @}
@z

@x l.641
      default:  fprintf(stderr, "%s: unexpected argument ignored.  ",
			command_name);
		fprintf(stderr, "Usage is: %s [-cnotv] file...\n",
			command_name);
@y
#ifdef _AMIGA
      default:  fprintf(stderr, get_string(MSG_WARNING_11B), command_name);
		fprintf(stderr, get_string(MSG_USAGE_11B), command_name);
#else
      default:  fprintf(stderr, "%s: unexpected argument ignored.  ",
			command_name);
		fprintf(stderr, "Usage is: %s [-cnotv] file...\n",
			command_name);
#endif
@z

@x l.659
    fprintf(stderr, "%s: expected a file name.  ", command_name);
    fprintf(stderr, "Usage is: %s [-cnotv] file-name...\n", command_name);
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_ERROR_11C), command_name);
    fprintf(stderr, get_string(MSG_USAGE_11B), command_name);
#else
    fprintf(stderr, "%s: expected a file name.  ", command_name);
    fprintf(stderr, "Usage is: %s [-cnotv] file-name...\n", command_name);
#endif
@z

@x l.661
    exit(-1);
  }
  do {
    @<Handle the file name in \verb|argv[arg]|@>
    arg++;
  } while (arg < argc);
}@}
@y
    exit(EXIT_FAILURE);
  }
  do {
    @<Handle the file name in \verb|argv[arg]|@>
    arg++;
  } while (arg < argc);
}
@| EXIT_FAILURE @}
@z

@x l.710
    if (c == '/') {
@y
#ifdef _AMIGA
    if ((c == '/') || (c == ':')) {
#else
    if (c == '/') {
#endif
@z

@x l.773
@{extern void pass1();
@y
@{extern void pass1(char *);
@z

@x l.787
@{void pass1(file_name)
     char *file_name;
@y
@{void pass1(char *file_name)
@z

@x l.791
    fprintf(stderr, "reading %s\n", file_name);
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_VERBOSE_14B), file_name);
#else
    fprintf(stderr, "reading %s\n", file_name);
#endif
@z

@x l.800
  @<Reverse cross-reference lists@>
}
@| pass1 @}
@y
  @<Reverse cross-reference lists@>
} @| pass1 @}
@z

@x l.835
    default:  fprintf(stderr,
		      "%s: unexpected @@ sequence ignored (%s, line %d)\n",
		      command_name, source_name, source_line);
@y
#ifdef _AMIGA
    default:  fprintf(stderr, get_string(MSG_WARNING_15A),
		      command_name, source_name, source_line);
#else
    default:  fprintf(stderr,
		      "%s: unexpected @@ sequence ignored (%s, line %d)\n",
		      command_name, source_name, source_line);
#endif
@z

@x l.894
\section{Writing the Latex File} \label{latex-file}
@y
\section{Writing the LaTeX File} \label{latex-file}
@z

@x l.902
If you don't like the format of definitions or indices or whatever,
@y
If you don't like the format of definitions or indexes or whatever,
@z

@x l.908
@{extern void write_tex();
@y
@{extern void write_tex(char *, char *);
@z

@x l.915
@{static void copy_scrap();		/* formats the body of a scrap */
static void print_scrap_numbers();	/* formats a list of scrap numbers */
static void format_entry();		/* formats an index entry */
static void format_user_entry();
@y
@{static void copy_scrap(FILE *);
  /* formats the body of a scrap */
static void print_scrap_numbers(FILE *, Scrap_Node *);
  /* formats a list of scrap numbers */
static void format_entry(Name *, FILE *, int);
  /* formats an index entry */
static void format_user_entry(Name *, FILE *);
@z

@x l.925
@{void write_tex(file_name, tex_name)
     char *file_name;
     char *tex_name;
@y
@{void write_tex(char *file_name, char *tex_name)
@z

@x l.932
      fprintf(stderr, "writing %s\n", tex_name);
@y
#ifdef _AMIGA
      fprintf(stderr, get_string(MSG_VERBOSE_17A), tex_name);
#else
      fprintf(stderr, "writing %s\n", tex_name);
#endif
@z

@x l.938
    fprintf(stderr, "%s: can't open %s\n", command_name, tex_name);
}
@| write_tex @}
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_WARNING_17A), command_name, tex_name);
#else
    fprintf(stderr, "%s: can't open %s\n", command_name, tex_name);
#endif
} @| write_tex @}
@z

@x l.996
$\langle$Interpret at-sequence {\footnotesize 18}$\rangle\equiv$
@y
${}\langle{}$Interpret at-sequence {\footnotesize 18}${}\rangle{}\equiv{}$
@z

@x l.1004
\mbox{}\verb@@    case 'o': @@$\langle$Write output file definition {\footnotesize 19a}$\rangle$\verb@@@@\\
@y
\mbox{}\verb@@    case 'o': @@${}\langle{}$Write output file
  definition {\footnotesize 19a}${}\rangle{}$\verb@@@@\\
@z

@x l.1039
  fputs(" }$\\equiv$\n", tex_file);
@y
  fputs(" }${}\\equiv{}$\n", tex_file);
@z

@x l.1053
  fprintf(tex_file, "$\\langle$%s {\\footnotesize ", name->spelling);
@y
  fprintf(tex_file, "${}\\langle{}$%s {\\footnotesize ", name->spelling);
@z

@x l.1055
  fputs("}$\\rangle\\equiv$\n", tex_file);
@y
  fputs("}${}\\rangle{}\\equiv{}$\n", tex_file);
@z

@x l.1112
    fputs("\\item File defined by scraps ", tex_file);
@y
#ifdef _AMIGA
    fputs(get_string(MSG_LATEX_20B), tex_file);
#else
    fputs("\\item File defined by scraps ", tex_file);
#endif
@z

@x l.1127
    fputs("\\item Macro defined by scraps ", tex_file);
@y
#ifdef _AMIGA
    fputs(get_string(MSG_LATEX_20C), tex_file);
#else
    fputs("\\item Macro defined by scraps ", tex_file);
#endif
@z

@x l.1136
      fputs("\\item Macro referenced in scraps ", tex_file);
@y
#ifdef _AMIGA
      fputs(get_string(MSG_LATEX_21A1), tex_file);
#else
      fputs("\\item Macro referenced in scraps ", tex_file);
#endif
@z

@x l.1140
      fputs("\\item Macro referenced in scrap ", tex_file);
@y
#ifdef _AMIGA
      fputs(get_string(MSG_LATEX_21A2), tex_file);
#else
      fputs("\\item Macro referenced in scrap ", tex_file);
#endif
@z

@x l.1146
    fputs("\\item Macro never referenced.\n", tex_file);
    fprintf(stderr, "%s: <%s> never referenced.\n",
@y
#ifdef _AMIGA
    fputs(get_string(MSG_LATEX_21A3), tex_file);
    fprintf(stderr, get_string(MSG_WARNING_21A),
#else
    fputs("\\item Macro never referenced.\n", tex_file);
    fprintf(stderr, "%s: <%s> never referenced.\n",
#endif
@z

@x l.1155
@{static void print_scrap_numbers(tex_file, scraps)
     FILE *tex_file;
     Scrap_Node *scraps;
@y
@{static void print_scrap_numbers(FILE *tex_file, Scrap_Node *scraps)
@z

@x l.1166
  fputs(".\n", tex_file);
}
@| print_scrap_numbers @}
@y
  fputs(".\n", tex_file);
} @| print_scrap_numbers @}
@z

@x l.1177
@{static void copy_scrap(file)
     FILE *file;
@y
@{static void copy_scrap(FILE *file)
@z

@x l.1196
    c = source_get();
  }
}
@| copy_scrap @}
@y
    c = source_get();
  }
} @| copy_scrap @}
@z

@x l.1244
  fprintf(file, "@@$\\langle$%s {\\footnotesize ", name->spelling);
@y
  fprintf(file, "@@${}\\langle{}$%s {\\footnotesize ", name->spelling);
@z

@x l.1249
    fprintf(stderr, "%s: scrap never defined <%s>\n",
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_WARNING_23B),
#else
    fprintf(stderr, "%s: scrap never defined <%s>\n",
#endif
@z

@x l.1252
  fputs("}$\\rangle$\\verb@@", file);
@y
  fputs("}${}\\rangle{}$\\verb@@", file);
@z

@x l.1266
\subsection{Generating the Indices}
@y
\subsection{Generating the Indexes}
@z

@x l.1295
@{static void format_entry(name, tex_file, file_flag)
     Name *name;
     FILE *tex_file;
     int file_flag;
@y
@{static void format_entry(Name *name, FILE *tex_file, int file_flag)
@z

@x l.1303
    name = name->rlink;
  }
}
@| format_entry @}
@y
    name = name->rlink;
  }
} @| format_entry @}
@z

@x l.1317
    fprintf(tex_file, "$\\langle$%s {\\footnotesize ", name->spelling);
@y
    fprintf(tex_file, "${}\\langle{}$%s {\\footnotesize ", name->spelling);
@z

@x l.1319
    fputs("}$\\rangle$ ", tex_file);
@y
    fputs("}${}\\rangle{}$ ", tex_file);
@z

@x l.1329
  fputs("{\\footnotesize Defined by scrap", tex_file);
  if (p->next) {
    fputs("s ", tex_file);
    print_scrap_numbers(tex_file, p);
  }
  else {
    putc(' ', tex_file);
@y
#ifdef _AMIGA
  if (p->next) {
    fputs(get_string(MSG_LATEX_25A1), tex_file);
    print_scrap_numbers(tex_file, p);
  }
  else {
    fputs(get_string(MSG_LATEX_25A2), tex_file);
#else
  fputs("{\\footnotesize Defined by scrap", tex_file);
  if (p->next) {
    fputs("s ", tex_file);
    print_scrap_numbers(tex_file, p);
  }
  else {
    putc(' ', tex_file);
#endif
@z

@x l.1363
    fputs("Referenced in scrap", tex_file);
    if (p->next) {
      fputs("s ", tex_file);
      print_scrap_numbers(tex_file, p);
    }
    else {
      putc(' ', tex_file);
@y
#ifdef _AMIGA
    if (p->next) {
      fputs(get_string(MSG_LATEX_25C1), tex_file);
      print_scrap_numbers(tex_file, p);
    }
    else {
      fputs(get_string(MSG_LATEX_25C2), tex_file);
#else
    fputs("Referenced in scrap", tex_file);
    if (p->next) {
      fputs("s ", tex_file);
      print_scrap_numbers(tex_file, p);
    }
    else {
      putc(' ', tex_file);
#endif
@z

@x l.1375
    fputs("Not referenced.", tex_file);
@y
#ifdef _AMIGA
    fputs(get_string(MSG_LATEX_25C3), tex_file);
#else
    fputs("Not referenced.", tex_file);
#endif
@z

@x l.1394
@{static void format_user_entry(name, tex_file)
     Name *name;
     FILE *tex_file;
@y
@{static void format_user_entry(Name *name, FILE *tex_file)
@z

@x l.1401
    name = name->rlink;
  }
}
@| format_user_entry @}
@y
    name = name->rlink;
  }
} @| format_user_entry @}
@z

@x l.1458
@{extern void write_html();
@y
@{extern void write_html(char *, char *);
@z

@x l.1465
@{static void copy_scrap();               /* formats the body of a scrap */
static void display_scrap_ref();        /* formats a scrap reference */
static void display_scrap_numbers();    /* formats a list of scrap numbers */
static void print_scrap_numbers();      /* pluralizes scrap formats list */
static void format_entry();             /* formats an index entry */
static void format_user_entry();
@y
@{static void copy_scrap(FILE *);
  /* formats the body of a scrap */
static void display_scrap_ref(FILE *, int);
  /* formats a scrap reference */
static void display_scrap_numbers(FILE *, Scrap_Node *);
  /* formats a list of scrap numbers */
static void print_scrap_numbers(FILE *, Scrap_Node *);
  /* pluralizes scrap formats list */
static void format_entry(Name *name, FILE *html_file, int file_flag);
  /* formats an index entry */
static void format_user_entry(Name *, FILE *);
@z

@x l.1477
@{void write_html(file_name, html_name)
     char *file_name;
     char *html_name;
@y
@{void write_html(char *file_name, char *html_name)
@z

@x l.1484
      fprintf(stderr, "writing %s\n", html_name);
@y
#ifdef _AMIGA
      fprintf(stderr, get_string(MSG_VERBOSE_17A), html_name);
#else
      fprintf(stderr, "writing %s\n", html_name);
#endif
@z

@x l.1490
    fprintf(stderr, "%s: can't open %s\n", command_name, html_name);
}
@| write_html @}
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_WARNING_17A), command_name, html_name);
#else
    fprintf(stderr, "%s: can't open %s\n", command_name, html_name);
#endif
} @| write_html @}
@z

@x l.1644
    fputs("File defined by ", html_file);
@y
#ifdef _AMIGA
    fputs(get_string(MSG_HTML_31C), html_file);
#else
    fputs("File defined by ", html_file);
#endif
@z

@x l.1653
    fputs("Macro defined by ", html_file);
@y
#ifdef _AMIGA
    fputs(get_string(MSG_HTML_31D), html_file);
#else
    fputs("Macro defined by ", html_file);
#endif
@z

@x l.1662
    fputs("Macro referenced in ", html_file);
@y
#ifdef _AMIGA
    fputs(get_string(MSG_HTML_31E1), html_file);
#else
    fputs("Macro referenced in ", html_file);
#endif
@z

@x l.1666
    fputs("Macro never referenced.\n", html_file);
    fprintf(stderr, "%s: <%s> never referenced.\n",
@y
#ifdef _AMIGA
    fputs(get_string(MSG_HTML_31E2), html_file);
    fprintf(stderr, get_string(MSG_WARNING_21A),
#else
    fputs("Macro never referenced.\n", html_file);
    fprintf(stderr, "%s: <%s> never referenced.\n",
#endif
@z

@x l.1674
@{static void display_scrap_ref(html_file, num)
     FILE *html_file;
     int num;
@y
@{static void display_scrap_ref(FILE *html_file, int num)
@z

@x l.1682
  fputs("</a>", html_file);
}
@| display_scrap_ref @}
@y
  fputs("</a>", html_file);
} @| display_scrap_ref @}
@z

@x l.1687
@{static void display_scrap_numbers(html_file, scraps)
     FILE *html_file;
     Scrap_Node *scraps;
@y
@{static void display_scrap_numbers(FILE *html_file, Scrap_Node *scraps)
@z

@x l.1696
    scraps = scraps->next;
  }
}
@| display_scrap_numbers @}
@y
    scraps = scraps->next;
  }
} @| display_scrap_numbers @}
@z

@x l.1702
@{static void print_scrap_numbers(html_file, scraps)
     FILE *html_file;
     Scrap_Node *scraps;
@y
@{static void print_scrap_numbers(FILE *html_file, Scrap_Node *scraps)
@z

@x l.1706
  fputs("scrap", html_file);
  if (scraps->next) fputc('s', html_file);
@y
#ifdef _AMIGA
  if (scraps->next) fputs(get_string(MSG_HTML_32C1), html_file);
  else fputs(get_string(MSG_HTML_32C2), html_file);
#else
  fputs("scrap", html_file);
  if (scraps->next) fputc('s', html_file);
#endif
@z

@x l.1710
  fputs(".\n", html_file);
}
@| print_scrap_numbers @}
@y
  fputs(".\n", html_file);
} @| print_scrap_numbers @}
@z

@x l.1720
@{static void copy_scrap(file)
     FILE *file;
@y
@{static void copy_scrap(FILE *file)
@z

@x l.1747
    c = source_get();
  }
}
@| copy_scrap @}
@y
    c = source_get();
  }
} @| copy_scrap @}
@z

@x l.1794
\subsection{Generating the Indices}
@y
\subsection{Generating the Indexes}
@z

@x l.1823
@{static void format_entry(name, html_file, file_flag)
     Name *name;
     FILE *html_file;
     int file_flag;
@y
@{static void format_entry(Name *name, FILE *html_file, int file_flag)
@z

@x l.1831
    name = name->rlink;
  }
}
@| format_entry @}
@y
    name = name->rlink;
  }
} @| format_entry @}
@z

@x l.1856
  fputs("Defined by ", html_file);
@y
#ifdef _AMIGA
  fputs(get_string(MSG_HTML_35C), html_file);
#else
  fputs("Defined by ", html_file);
#endif
@z

@x l.1872
    fputs("Referenced in ", html_file);
@y
#ifdef _AMIGA
    fputs(get_string(MSG_HTML_35E1), html_file);
#else
    fputs("Referenced in ", html_file);
#endif
@z

@x l.1876
    fputs("Not referenced.\n", html_file);
@y
#ifdef _AMIGA
    fputs(get_string(MSG_HTML_35E2), html_file);
#else
    fputs("Not referenced.\n", html_file);
#endif
@z

@x l.1894
@{static void format_user_entry(name, html_file)
     Name *name;
     FILE *html_file;
@y
@{static void format_user_entry(Name *name, FILE *html_file)
@z

@x l.1901
    name = name->rlink;
  }
}
@| format_user_entry @}
@y
    name = name->rlink;
  }
} @| format_user_entry @}
@z

@x l.1947
@{extern void write_files();
@y
@{extern void write_files(Name *);
@z

@x l.1951
@{void write_files(files)
     Name *files;
@y
@{void write_files(Name *files)
@z

@x l.1957
    files = files->rlink;
  }
}
@| write_files @}
@y
    files = files->rlink;
  }
} @| write_files @}
@z

@x l.1962
We call \verb|tempnam|, causing it to create a file name in the
@y
We call \verb|tmpnam|, causing it to create a file name in the
@z

@x l.1976
  char *temp_name = tempnam(".", 0);
@y
  char *temp_name = tmpnam(NULL);
#ifdef __SASC
  temp_name += 2; /* Bump temp_name by 2 characters to get past the "T:"
    that is tacked on by SAS/C. */
#endif
@z

@x l.1979
    fprintf(stderr, "%s: can't create %s for a temporary file\n",
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_ERROR_38),
#else
    fprintf(stderr, "%s: can't create %s for a temporary file\n",
#endif
@z

@x l.1981
    exit(-1);
@y
    exit(EXIT_FAILURE);
@z

@x l.1984
    fprintf(stderr, "writing %s\n", files->spelling);
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_VERBOSE_17A), files->spelling);
#else
    fprintf(stderr, "writing %s\n", files->spelling);
#endif
@z

@x l.1999
  FILE *old_file = fopen(files->spelling, "r");
  if (old_file) {
    int x, y;
    temp_file = fopen(temp_name, "r");
    do {
      x = getc(old_file);
      y = getc(temp_file);
    } while (x == y && x != EOF);
    fclose(old_file);
    fclose(temp_file);
    if (x == y)
      remove(temp_name);
    else {
      remove(files->spelling);
      rename(temp_name, files->spelling);
    }
  }
  else
    rename(temp_name, files->spelling);
@y
  FILE *old_file = fopen(files->spelling, "r");
  if (old_file) {
    char x[BUFSIZ], y[BUFSIZ];
    int x_size, y_size;
    temp_file = fopen(temp_name, "r");
    do {
      x_size = fread(x, 1, BUFSIZ, old_file);
      y_size = fread(y, 1, BUFSIZ, temp_file);
    } while ((x_size == y_size) && !memcmp(x, y, x_size) &&
             !feof(old_file) && !feof(temp_file));
    if ((x_size != y_size) || memcmp(x, y , x_size)) {
      fclose(old_file);
      fclose(temp_file);
      remove(files->spelling);
      rename(temp_name, files->spelling);
    } else {
      fclose(old_file);
      fclose(temp_file);
      remove(temp_name);
    }
  }
  else
    rename(temp_name, files->spelling);
@z

@x l.2030
@{extern void source_open(); /* pass in the name of the source file */
extern int source_get();   /* no args; returns the next char or EOF */
@y
@{extern void source_open(char *);
  /* pass in the name of the source file */
extern int source_get(void);
  /* no args; returns the next char or EOF */
@z

@x l.2074
@{int source_get()
@y
@{int source_get(void)
@z

@x l.2083
    default:   source_peek = getc(source_file);
	       return c;
  }
}
@| source_get @}
@y
    default:   source_peek = getc(source_file);
	       return c;
  }
} @| source_get @}
@z

@x l.2117
      default:  fprintf(stderr, "%s: bad @@ sequence (%s, line %d)\n",
			command_name, source_name, source_line);
		exit(-1);
@y
#ifdef _AMIGA
      default:  fprintf(stderr, get_string(MSG_ERROR_42A),
			command_name, source_name, source_line);
#else
      default:  fprintf(stderr, "%s: bad @@ sequence (%s, line %d)\n",
			command_name, source_name, source_line);
#endif
		exit(EXIT_FAILURE);
@z

@x l.2127
    fprintf(stderr, "%s: include nesting too deep (%s, %d)\n",
	    command_name, source_name, source_line);
    exit(-1);
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_ERROR_42B1),
	    command_name, source_name, source_line);
#else
    fprintf(stderr, "%s: include nesting too deep (%s, %d)\n",
	    command_name, source_name, source_line);
#endif
    exit(EXIT_FAILURE);
@z

@x l.2140
    fprintf(stderr, "%s: can't open include file %s\n",
     command_name, source_name);
    exit(-1);
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_ERROR_42B2),
     command_name, source_name);
#else
    fprintf(stderr, "%s: can't open include file %s\n",
     command_name, source_name);
#endif
    exit(EXIT_FAILURE);
@z

@x l.2160
      fprintf(stderr, "%s: unexpected characters after file name (%s, %d)\n",
	      command_name, source_name, source_line);
      exit(-1);
@y
#ifdef _AMIGA
      fprintf(stderr, get_string(MSG_ERROR_43A),
	      command_name, source_name, source_line);
#else
      fprintf(stderr, "%s: unexpected characters after file name (%s, %d)\n",
	      command_name, source_name, source_line);
#endif
      exit(EXIT_FAILURE);
@z

@x l.2189
@{void source_open(name)
     char *name;
@y
@{void source_open(char *name)
@z

@x l.2194
    fprintf(stderr, "%s: couldn't open %s\n", command_name, name);
    exit(-1);
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_ERROR_43C), command_name, name);
#else
    fprintf(stderr, "%s: couldn't open %s\n", command_name, name);
#endif
    exit(EXIT_FAILURE);
@z

@x l.2201
  include_depth = 0;
}
@| source_open @}
@y
  include_depth = 0;
} @| source_open @}
@z

@x l.2241
@{extern void init_scraps();
extern int collect_scrap();
extern int write_scraps();
extern void write_scrap_ref();
extern void write_single_scrap_ref();
@y
@{extern void init_scraps(void);
extern int collect_scrap(void);
extern int write_scraps(FILE *, Scrap_Node *, int, char *, char, char, char);
extern void write_scrap_ref(FILE *, int, int, int *);
extern void write_single_scrap_ref(FILE *, int);
@z

@x l.2250
@{void init_scraps()
@y
@{void init_scraps(void)
@z

@x l.2253
  SCRAP[0] = (ScrapEntry *) arena_getmem(256 * sizeof(ScrapEntry));
}
@| init_scraps @}
@y
  SCRAP[0] = (ScrapEntry *) arena_getmem(256 * sizeof(ScrapEntry));
} @| init_scraps @}
@z

@x l.2259
@{void write_scrap_ref(file, num, first, page)
     FILE *file;
     int num;
     int first;
     int *page;
@y
@{void write_scrap_ref(FILE *file, int num, int first, int *page)
@z

@x l.2278
    @<Warn (only once) about needing to rerun after Latex@>
@y
    @<Warn (only once) about needing to rerun after LaTeX@>
@z

@x l.2280
  *page = scrap_array(num).page;
}
@| write_scrap_ref @}
@y
  *page = scrap_array(num).page;
} @| write_scrap_ref @}
@z

@x l.2285
@{void write_single_scrap_ref(file, num)
     FILE *file;
     int num;
@y
@{void write_single_scrap_ref(FILE *file, int num)
@z

@x l.2290
  write_scrap_ref(file, num, TRUE, &page);
}
@| write_single_scrap_ref @}
@y
  write_scrap_ref(file, num, TRUE, &page);
} @| write_single_scrap_ref @}
@z

@x l.2298
    fprintf(stderr, "%s: you'll need to rerun nuweb after running latex\n",
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_WARNING_45C),
#else
    fprintf(stderr, "%s: you'll need to rerun nuweb after running latex\n",
#endif
@z

@x l.2323
@{static void push(c, manager)
     char c;
     Manager *manager;
@y
@{static void push(char c, Manager *manager)
@z

@x l.2336
  manager->index = index;
}
@| push @}
@y
  manager->index = index;
} @| push @}
@z

@x l.2341
@{static void pushs(s, manager)
     char *s;
     Manager *manager;
@y
@{static void pushs(char *s, Manager *manager)
@z

@x l.2346
    push(*s++, manager);
}
@| pushs @}
@y
    push(*s++, manager);
} @| pushs @}
@z

@x l.2352
@{int collect_scrap()
@y
@{int collect_scrap(void)
@z

@x l.2356
  @<Accumulate scrap and return \verb|scraps++|@>
}
@| collect_scrap @}
@y
  @<Accumulate scrap and return \verb|scraps++|@>
} @| collect_scrap @}
@z

@x l.2380
      case EOF: fprintf(stderr, "%s: unexpect EOF in scrap (%s, %d)\n",
			command_name, scrap_array(scraps).file_name,
			scrap_array(scraps).file_line);
		exit(-1);
@y
#ifdef _AMIGA
      case EOF: fprintf(stderr, get_string(MSG_ERROR_47B),
			command_name, scrap_array(scraps).file_name,
			scrap_array(scraps).file_line);
#else
      case EOF: fprintf(stderr, "%s: unexpect EOF in scrap (%s, %d)\n",
			command_name, scrap_array(scraps).file_name,
			scrap_array(scraps).file_line);
#endif
		exit(EXIT_FAILURE);
@z

@x l.2406
    default : fprintf(stderr, "%s: unexpected @@%c in scrap (%s, %d)\n",
		      command_name, c, source_name, source_line);
	      exit(-1);
@y
#ifdef _AMIGA
    default : fprintf(stderr, get_string(MSG_ERROR_47C),
		      command_name, c, source_name, source_line);
#else
    default : fprintf(stderr, "%s: unexpected @@%c in scrap (%s, %d)\n",
		      command_name, c, source_name, source_line);
#endif
	      exit(EXIT_FAILURE);
@z

@x l.2441
    exit(-1);
@y
    exit(EXIT_FAILURE);
@z

@x l.2484
@{static char pop(manager)
     Manager *manager;
@y
@{static char pop(Manager *manager)
@z

@x l.2495
  manager->index = index;
  return c;
}
@| pop @}
@y
  manager->index = index;
  return c;
} @| pop @}
@z

@x l.2503
@{static Name *pop_scrap_name(manager)
     Manager *manager;
@y
@{static Name *pop_scrap_name(Manager *manager)
@z

@x l.2514
      c = pop(manager);
    }
  }
}
@| pop_scrap_name @}
@y
      c = pop(manager);
    }
  }
} @| pop_scrap_name @}
@z

@x l.2537
    fprintf(stderr, "%s: found an internal problem (1)\n", command_name);
    exit(-1);
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_ERROR_50A), command_name);
#else
    fprintf(stderr, "%s: found an internal problem (1)\n", command_name);
#endif
    exit(EXIT_FAILURE);
@z

@x l.2544
@{int write_scraps(file, defs, global_indent, indent_chars,
		   debug_flag, tab_flag, indent_flag)
     FILE *file;
     Scrap_Node *defs;
     int global_indent;
     char *indent_chars;
     char debug_flag;
     char tab_flag;
     char indent_flag;
@y
@{int write_scraps(FILE *file, Scrap_Node *defs, int global_indent,
  char *indent_chars, char debug_flag, char tab_flag, char indent_flag)
@z

@x l.2559
  return indent + global_indent;
}
@| write_scraps @}
@y
  return indent + global_indent;
} @| write_scraps @}
@z

@x l.2649
    fprintf(stderr, "%s: recursive macro discovered involving <%s>\n",
	    command_name, name->spelling);
    exit(-1);
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_ERROR_52C1),
	    command_name, name->spelling);
#else
    fprintf(stderr, "%s: recursive macro discovered involving <%s>\n",
	    command_name, name->spelling);
#endif
    exit(EXIT_FAILURE);
@z

@x l.2661
    fprintf(stderr, "%s: macro never defined <%s>\n",
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_WARNING_52C2),
#else
    fprintf(stderr, "%s: macro never defined <%s>\n",
#endif
@z

@x l.2669
@{extern void collect_numbers();
@y
@{extern void collect_numbers(char *);
@z

@x l.2673
@{void collect_numbers(aux_name)
     char *aux_name;
@y
@{void collect_numbers(char *aux_name)
@z

@x l.2699
      @<Add letters to scraps with duplicate page numbers@>
    }
  }
}
@| collect_numbers @}
@y
      @<Add letters to scraps with duplicate page numbers@>
    }
  }
} @| collect_numbers @}
@z

@x l.2755
@{extern Name *collect_file_name();
extern Name *collect_macro_name();
extern Name *collect_scrap_name();
extern Name *name_add();
extern Name *prefix_add();
extern char *save_string();
extern void reverse_lists();
@y
@{extern Name *collect_file_name(void);
extern Name *collect_macro_name(void);
extern Name *collect_scrap_name(void);
extern Name *name_add(Name **, char *);
extern Name *prefix_add(Name **, char *);
extern char *save_string(char *);
extern void reverse_lists(Name *);
@z

@x l.2767
static int compare(x, y)
     char *x;
     char *y;
@y
static int compare(char *x, char *y)
@z

@x l.2790
  else return EQUAL;
}
@| compare LESS GREATER EQUAL PREFIX EXTENSION @}
@y
  else return EQUAL;
} @| compare LESS GREATER EQUAL PREFIX EXTENSION @}
@z

@x l.2796
@{char *save_string(s)
     char *s;
@y
@{char *save_string(char *s)
@z

@x l.2801
  return new;
}
@| save_string @}
@y
  return new;
} @| save_string @}
@z

@x l.2806
@{static int ambiguous_prefix();
@y
@{static int ambiguous_prefix(Name *, char *);
@z

@x l.2808
Name *prefix_add(root, spelling)
     Name **root;
     char *spelling;
@y
Name *prefix_add(Name **root, char *spelling)
@z

@x l.2827
  @<Create new name entry@>
}
@| prefix_add @}
@y
  @<Create new name entry@>
} @| prefix_add @}
@z

@x l.2839
    fprintf(stderr,
	    "%s: ambiguous prefix @@<%s...@@> (%s, line %d)\n",
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_WARNING_56B),
#else
    fprintf(stderr,
	    "%s: ambiguous prefix @@<%s...@@> (%s, line %d)\n",
#endif
@z

@x l.2845
@{static int ambiguous_prefix(node, spelling)
     Name *node;
     char *spelling;
@y
@{static int ambiguous_prefix(Name *node, char *spelling)
@z

@x l.2880
@{static int robs_strcmp(x, y)
     char *x;
     char *y;
@y
@{static int robs_strcmp(char *x, char *y)
@z

@x l.2907
  return xc - yc;
}
@| robs_strcmp @}
@y
  return xc - yc;
} @| robs_strcmp @}
@z

@x l.2912
@{Name *name_add(root, spelling)
     Name **root;
     char *spelling;
@y
@{Name *name_add(Name **root, char *spelling)
@z

@x l.2927
  @<Create new name entry@>
}
@| name_add @}
@y
  @<Create new name entry@>
} @| name_add @}
@z

@x l.2952
@{Name *collect_file_name()
@y
@{Name *collect_file_name(void)
@z

@x l.2966
    fprintf(stderr, "%s: expected file name (%s, %d)\n",
	    command_name, source_name, start_line);
    exit(-1);
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_ERROR_59A1),
	    command_name, source_name, start_line);
#else
    fprintf(stderr, "%s: expected file name (%s, %d)\n",
	    command_name, source_name, start_line);
#endif
    exit(EXIT_FAILURE);
@z

@x l.2974
    fprintf(stderr, "%s: expected @@{ after file name (%s, %d)\n",
	    command_name, source_name, start_line);
    exit(-1);
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_ERROR_59A2),
	    command_name, source_name, start_line);
#else
    fprintf(stderr, "%s: expected @@{ after file name (%s, %d)\n",
	    command_name, source_name, start_line);
#endif
    exit(EXIT_FAILURE);
@z

@x l.2978
  return new_name;
}
@| collect_file_name @}
@y
  return new_name;
} @| collect_file_name @}
@z

@x l.2997
	  default : fprintf(stderr, "%s: unexpected per-file flag (%s, %d)\n",
@y
#ifdef _AMIGA
	  default : fprintf(stderr, get_string(MSG_WARNING_59B),
#else
	  default : fprintf(stderr, "%s: unexpected per-file flag (%s, %d)\n",
#endif
@z

@x l.3010
Name terminated by \verb+\n+ or \verb+@@{+; but keep skipping until \verb+@@{+
@y
Name terminated by \verb+\n+ or \verb+@@{+; but keep skipping until
\verb+@@{+.
@z

@x l.3012
@{Name *collect_macro_name()
@y
@{Name *collect_macro_name(void)
@z

@x l.3036
  fprintf(stderr, "%s: expected macro name (%s, %d)\n",
	  command_name, source_name, start_line);
  exit(-1);
  return NULL;  /* unreachable return to avoid warnings on some compilers */
}
@| collect_macro_name @}
@y
#ifdef _AMIGA
  fprintf(stderr, get_string(MSG_ERROR_60A),
	  command_name, source_name, start_line);
#else
  fprintf(stderr, "%s: expected macro name (%s, %d)\n",
	  command_name, source_name, start_line);
#endif
  exit(EXIT_FAILURE);
  return NULL;  /* unreachable return to avoid warnings on some compilers */
} @| collect_macro_name @}
@z

@x l.3051
    default:  fprintf(stderr,
		      "%s: unexpected @@%c in macro name (%s, %d)\n",
		      command_name, c, source_name, start_line);
	      exit(-1);
@y
#ifdef _AMIGA
    default:  fprintf(stderr, get_string(MSG_ERROR_60B),
		      command_name, c, source_name, start_line);
#else
    default:  fprintf(stderr,
		      "%s: unexpected @@%c in macro name (%s, %d)\n",
		      command_name, c, source_name, start_line);
#endif
	      exit(EXIT_FAILURE);
@z

@x l.3068
    fprintf(stderr, "%s: empty scrap name (%s, %d)\n",
	    command_name, source_name, source_line);
    exit(-1);
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_ERROR_61A),
	    command_name, source_name, source_line);
#else
    fprintf(stderr, "%s: empty scrap name (%s, %d)\n",
	    command_name, source_name, source_line);
#endif
    exit(EXIT_FAILURE);
@z

@x l.3083
    fprintf(stderr, "%s: expected @@{ after macro name (%s, %d)\n",
	    command_name, source_name, start_line);
    exit(-1);
@y
#ifdef _AMIGA
    fprintf(stderr, get_string(MSG_ERROR_61B),
	    command_name, source_name, start_line);
#else
    fprintf(stderr, "%s: expected @@{ after macro name (%s, %d)\n",
	    command_name, source_name, start_line);
#endif
    exit(EXIT_FAILURE);
@z

@x l.3091
Terminated by \verb+@@>+
@y
Terminated by \verb+@@>+.
@z

@x l.3093
@{Name *collect_scrap_name()
@y
@{Name *collect_scrap_name(void)
@z

@x l.3111
		   fprintf(stderr,
			   "%s: unexpected character in macro name (%s, %d)\n",
			   command_name, source_name, source_line);
		   exit(-1);
@y
#ifdef _AMIGA
		   fprintf(stderr, get_string(MSG_ERROR_62A1),
			   command_name, source_name, source_line);
#else
		   fprintf(stderr,
			   "%s: unexpected character in macro name (%s, %d)\n",
			   command_name, source_name, source_line);
#endif
		   exit(EXIT_FAILURE);
@z

@x l.3121
  fprintf(stderr, "%s: unexpected end of file (%s, %d)\n",
	  command_name, source_name, source_line);
  exit(-1);
  return NULL;  /* unreachable return to avoid warnings on some compilers */
}
@| collect_scrap_name @}
@y
#ifdef _AMIGA
  fprintf(stderr, get_string(MSG_ERROR_62A2),
	  command_name, source_name, source_line);
#else
  fprintf(stderr, "%s: unexpected end of file (%s, %d)\n",
	  command_name, source_name, source_line);
#endif
  exit(EXIT_FAILURE);
  return NULL;  /* unreachable return to avoid warnings on some compilers */
} @| collect_scrap_name @}
@z

@x l.3140
	      exit(-1);
@y
	      exit(EXIT_FAILURE);
@z

@x l.3146
@{static Scrap_Node *reverse();	/* a forward declaration */
@y
@{static Scrap_Node *reverse(Scrap_Node *); /* a forward declaration */
@z

@x l.3148
void reverse_lists(names)
     Name *names;
@y
void reverse_lists(Name *names)
@z

@x l.3155
    names = names->rlink;
  }
}
@| reverse_lists @}
@y
    names = names->rlink;
  }
} @| reverse_lists @}
@z

@x l.3164
@{static Scrap_Node *reverse(a)
     Scrap_Node *a;
@y
@{static Scrap_Node *reverse(Scrap_Node *a)
@z

@x l.3177
  return a;
}
@| reverse @}
@y
  return a;
} @| reverse @}
@z

@x l.3223
@{static Goto_Node *goto_lookup(c, g)
     char c;
     Goto_Node *g;
@y
@{static Goto_Node *goto_lookup(char c, Goto_Node *g)
@z

@x l.3233
    return NULL;
}
@| goto_lookup @}
@y
    return NULL;
} @| goto_lookup @}
@z

@x l.3242
@{extern void search();
@y
@{extern void search(void);
@z

@x l.3246
@{static void build_gotos();
static int reject_match();
@y
@{static void build_gotos(Name *);
static int reject_match(Name *, char, Manager *);
@z

@x l.3249
void search()
@y
void search(void)
@z

@x l.3260
  @<Search scraps@>
}
@| search @}
@y
  @<Search scraps@>
} @| search @}
@z

@x l.3267
@{static void build_gotos(tree)
     Name *tree;
@y
@{static void build_gotos(Name *tree)
@z

@x l.3273
    tree = tree->llink;
  }
}
@| build_gotos @}
@y
    tree = tree->llink;
  }
} @| build_gotos @}
@z

@x l.3418
static int op_char(c)
     char c;
@y
static int op_char(char c)
@z

@x l.3427
      return FALSE;
  }
}
@| sym_char op_char @}
@y
      return FALSE;
  }
} @| sym_char op_char @}
@z

@x l.3433
@{static int reject_match(name, post, reader)
     Name *name;
     char post;
     Manager *reader;
@y
@{static int reject_match(Name *name, char post, Manager *reader)
@z

@x l.3451
  return FALSE;
}
@| reject_match @}
@y
  return FALSE;
} @| reject_match @}
@z

@x l.3470
@{extern void *arena_getmem();
extern void arena_free();
@y
@{extern void *arena_getmem(size_t);
extern void arena_free(void);
@z

@x l.3504
@{void *arena_getmem(n)
     size_t n;
@y
@{void *arena_getmem(size_t n)
@z

@x l.3515
  @<Find a new chunk of memory@>
}
@| arena_getmem @}
@y
  @<Find a new chunk of memory@>
} @| arena_getmem @}
@z

@x l.3565
  arena = &first;
}
@| arena_free @}
@y
  arena = &first;
} @| arena_free @}
@z

@x l.3570
\chapter{Indices} \label{indices}
@y
\chapter{Multilinguality} \label{multilinguality}

The Amiga operating system (and maybe some other operating systems as
well), starting with version~2.1, is inherently multilingual.  With the
help of system catalogs, any decent program interface can be made sensitive
to the language the user wants to be addressed with.  All terminal output
strings and \LaTeX\ output strings were located and replaced by references
to an external array \verb|AppStrings|.  The English defaults of these
strings can be overwritten by the entries of translated catalogs.  The
following include file \verb|cweb.h| contains a complete description of all
strings used in this extended \verb|NUWEB| system.

@d Include files
@{#ifdef _AMIGA
#include <libraries/locale.h>
#include <proto/locale.h>
#include <proto/exec.h>

#define get_string(n) AppStrings[n].as_Str /* reference string n */

#include "catalogs/nuweb.h"

#ifndef STRINGARRAY
struct AppString
{
  LONG   as_ID;
  STRPTR as_Str;
};

extern struct AppString AppStrings[];
#endif
#endif
@| get_string AppStrings as_Str STRINGARRAY AppString as_ID @}

We need some handles to access the system library and the language catalogs.

@d Global variable definitions
@{#ifdef _AMIGA
struct Library *LocaleBase; /* pointer to the locale library */
struct Catalog *catalog; /* pointer to the external catalog, when present */
int i; /* global counter for list of strings */
#endif
@| LocaleBase catalog @}

@d Global variable declarations
@{extern struct Library *LocaleBase;
  /* pointer to the locale library */
extern struct Catalog *catalog;
  /* pointer to the external catalog, when present */
extern int i;
  /* global counter for list of strings */
@}

Version 2.1 or higher of the Amiga operating system (represented as
internal version~38) will replace the complete set of terminal output
strings by an external translation in accordance to the system default
language.

@d Use catalog translations
@{#ifdef _AMIGA
@<Set up exit trap@>
@<Set up interrupt handler@>

if(LocaleBase = OpenLibrary("locale.library", 38L)) {
  if(catalog = OpenCatalog(NULL, "nuweb.catalog", OC_BuiltInLanguage,
                           "english", TAG_DONE)) {
    for(i = MSG_WARNING_11B; i <= MSG_ERROR_62A2; i++)
      AppStrings[i].as_Str = GetCatalogStr(catalog, i, AppStrings[i].as_Str);
  }
}
#endif
@| OpenLibrary OpenCatalog @}

At the end of the program and especially in case of an user break we must
take care of the opened resources like system libraries and catalog files.
ANSI-C provides ``exit traps'' and ``exception handlers'' for this purpose.
\verb|atexit| returns \verb|NULL| if the trap is set up correctly and a code
other than \verb|NULL| in case of error.  It is very important that the
``exit traps'' {\em are\/} set up properly, so we better quit further
processing in case of an error.

@d Set up exit trap
@{if(atexit(&CloseSystemResources))
  exit(EXIT_FAILURE); /* Exit trap could not be set up */
@| atexit @}

It is essential to close the pointer references to the language catalog and
to the system library before shutting down the program itself.  This
program will only be left by calls to the \verb|exit| function, so we use
a nice feature of the C language, socalled ``exit traps.''

@d Function prototypes
@{#ifdef _AMIGA
extern void CloseSystemResources(void);
#endif
@| CloseSystemResources @}

The only purpose of \verb|CloseSystemResources| is to take care of
the opened files.

@o global.c
@{#ifdef _AMIGA
void CloseSystemResources(void) {
  if(LocaleBase) {
    CloseCatalog(catalog);
    CloseLibrary(LocaleBase);
  }
}
#endif
@| CloseCatalog CloseLibrary @}

After the ``exit trap'' is set up, it is very convenient to add another
feature of modern technology, the possibility to abort the program with
``Control-C'' or ``Control-D''.  The C standard library provides a
mechanism for this purpose with its \verb|signal| routine.

@d Set up interrupt handler
@{if(signal(SIGINT, &catch_break) == SIG_ERR)
  exit(EXIT_FAILURE); /* Interrupt handler could not be set up */
@| signal SIGINT SIG_ERR @}

The \verb|signal| function and the macros for the interrupt codes are given
in the following standard header file.

@d Include files
@{#ifdef _AMIGA
#include <signal.h>
#endif
@}

The action to be taken at the last moments of the run is quite simple,
we only call \verb|exit|, thus activating the ``exit trap'' for
resource handling.

@d Function prototypes
@{#ifdef _AMIGA
extern void catch_break(int);
#endif
@| catch_break @}

@o global.c
@{#ifdef _AMIGA
void catch_break(int dummy) {
  exit(EXIT_FAILURE);
}
#endif
@| dummy @}


\chapter{Indexes} \label{indexes}
@z

@x l.3572
Three sets of indices can be created automatically: an index of file
@y
Three sets of indexes can be created automatically: an index of file
@z

@x l.3590
Therefore, it seems better to leave it this up to the user.
@y
Therefore, it seems better to leave this up to the user.
@z
